"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildAndDeployApi = exports.runCLI = exports.stopTestEnvironment = exports.initTestEnvironment = void 0;
var generate_name_1 = require("./generate-name");
var path_1 = __importDefault(require("path"));
var spawn_command_1 = __importDefault(require("spawn-command"));
var axios_1 = __importDefault(require("axios"));
var fs_1 = __importDefault(require("fs"));
var monorepoCli = __dirname + "/../../../cli/bin/w3";
var npmCli = __dirname + "/../../cli/bin/w3";
exports.initTestEnvironment = function (cli) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, exitCode, stderr, stdout, providers, ipfs, ethereum, ensAddresses, e_1;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0: return [4 /*yield*/, exports.runCLI({
                    args: ["test-env", "up"],
                    cli: cli,
                })];
            case 1:
                _a = _b.sent(), exitCode = _a.exitCode, stderr = _a.stderr, stdout = _a.stdout;
                if (exitCode) {
                    throw Error("initTestEnvironment failed to start test environment.\nExit Code: " + exitCode + "\nStdErr: " + stderr + "\nStdOut: " + stdout);
                }
                _b.label = 2;
            case 2:
                _b.trys.push([2, 5, , 6]);
                return [4 /*yield*/, axios_1.default.get("http://localhost:4040/providers")];
            case 3:
                providers = (_b.sent()).data;
                ipfs = providers.ipfs;
                ethereum = providers.ethereum;
                return [4 /*yield*/, axios_1.default.get("http://localhost:4040/deploy-ens")];
            case 4:
                ensAddresses = (_b.sent()).data;
                return [2 /*return*/, __assign({ ipfs: ipfs,
                        ethereum: ethereum }, ensAddresses)];
            case 5:
                e_1 = _b.sent();
                throw Error("Dev server must be running at port 4040\n" + e_1);
            case 6: return [2 /*return*/];
        }
    });
}); };
exports.stopTestEnvironment = function (cli) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, exitCode, stderr;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0: return [4 /*yield*/, exports.runCLI({
                    args: ["test-env", "down"],
                    cli: cli,
                })];
            case 1:
                _a = _b.sent(), exitCode = _a.exitCode, stderr = _a.stderr;
                if (exitCode) {
                    throw Error("stopTestEnvironment failed to stop test environment.\nExit Code: " + exitCode + "\nStdErr: " + stderr);
                }
                return [2 /*return*/, Promise.resolve()];
        }
    });
}); };
exports.runCLI = function (options) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, exitCode, stdout, stderr;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0: return [4 /*yield*/, new Promise(function (resolve, reject) {
                    var _a, _b;
                    if (!options.cwd) {
                        // Make sure to set an absolute working directory
                        var cwd = process.cwd();
                        options.cwd = cwd[0] !== "/" ? path_1.default.resolve(__dirname, cwd) : cwd;
                    }
                    // Resolve the CLI
                    if (!options.cli) {
                        if (fs_1.default.existsSync(monorepoCli)) {
                            options.cli = monorepoCli;
                        }
                        else if (fs_1.default.existsSync(npmCli)) {
                            options.cli = npmCli;
                        }
                        else {
                            throw Error("runCli is missing a valid CLI path, please provide one");
                        }
                    }
                    var command = "node " + options.cli + " " + options.args.join(" ");
                    var child = spawn_command_1.default(command, { cwd: options.cwd });
                    var stdout = "";
                    var stderr = "";
                    child.on("error", function (error) {
                        reject(error);
                    });
                    (_a = child.stdout) === null || _a === void 0 ? void 0 : _a.on("data", function (data) {
                        stdout += data.toString();
                    });
                    (_b = child.stderr) === null || _b === void 0 ? void 0 : _b.on("data", function (data) {
                        stderr += data.toString();
                    });
                    child.on("exit", function (exitCode) {
                        resolve([exitCode, stdout, stderr]);
                    });
                })];
            case 1:
                _a = __read.apply(void 0, [_b.sent(), 3]), exitCode = _a[0], stdout = _a[1], stderr = _a[2];
                return [2 /*return*/, {
                        exitCode: exitCode,
                        stdout: stdout,
                        stderr: stderr,
                    }];
        }
    });
}); };
function buildAndDeployApi(apiAbsPath, ipfsProvider, ensAddress) {
    return __awaiter(this, void 0, void 0, function () {
        var apiEns, _a, exitCode, stdout, stderr, extractCID, result, apiCid;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    apiEns = generate_name_1.generateName() + ".eth";
                    return [4 /*yield*/, exports.runCLI({
                            args: [
                                "build",
                                "--manifest-file",
                                apiAbsPath + "/web3api.yaml",
                                "--output-dir",
                                apiAbsPath + "/build",
                                "--ipfs",
                                ipfsProvider,
                                "--test-ens",
                                ensAddress + "," + apiEns,
                            ],
                        })];
                case 1:
                    _a = _b.sent(), exitCode = _a.exitCode, stdout = _a.stdout, stderr = _a.stderr;
                    if (exitCode !== 0) {
                        console.error("w3 exited with code: " + exitCode);
                        console.log("stderr:\n" + stderr);
                        console.log("stdout:\n" + stdout);
                        throw Error("w3 CLI failed");
                    }
                    extractCID = /IPFS { (([A-Z]|[a-z]|[0-9])*) }/;
                    result = stdout.match(extractCID);
                    if (!result) {
                        throw Error("W3 CLI output missing IPFS CID.\nOutput: " + stdout);
                    }
                    apiCid = result[1];
                    return [2 /*return*/, {
                            ensDomain: apiEns,
                            ipfsCid: apiCid,
                        }];
            }
        });
    });
}
exports.buildAndDeployApi = buildAndDeployApi;
//# sourceMappingURL=index.js.map